--------------------------------------- Back Scratcher’s code ------------------------------------------
//Sketch by Jasper Witten.
//Back Scratching machine with controlled speed & angle of the servo.

#include <Servo.h>
Servo borstelServo;
int pos = 0;      //Position of the servo.

int potPin1 = A0; //Analog Pin 0 for the potmeter.
int potPin2 = A1; //Analog Pin 1 for the potmeter.

int angleS = 30;  //Variable for the angle of the servo.
int speedS;       //Variable for the speed of the servo.

void setup() {
  borstelServo.attach(9); //Use pin 9 for the servo.
}

void loop() {
  angleS = analogRead(potPin1);
  speedS = analogRead(potPin2);
  angleS = map(angleS, 0, 1023, 0 , 60); //Map the potmeter for the angle to 0-60.
  speedS = map(speedS, 0, 1023, 3, 30);  //Map the potmeter for the speed to 0-30.

//Making the servo go back and forth over a controlled angle.
  for (pos = 90 - angleS; pos <= 90 + angleS; pos += 3) { 
    borstelServo.write(pos);
    delay(speedS); //Using delay for the speed to get more fluent speed control.

    //Looping the mapping & reading to get rid of delay in feedback.
    angleS = analogRead(potPin1);
    speedS = analogRead(potPin2);
    angleS = map(angleS, 0, 1023, 0 , 60);
    speedS = map(speedS, 0, 1023, 3, 30);
  }

//Making the servo go back and forth over a controlled angle.
  for (pos = 90 + angleS ; pos >= 90 - angleS; pos -= 3) { 
    borstelServo.write(pos);
    delay(speedS ); //Using delay for the speed to get more fluent speed control.

    //Looping the mapping & reading to get rid of delay in feedback.
    angleS = analogRead(potPin1);
    speedS = analogRead(potPin2);
    angleS = map(angleS, 0, 1023, 0 , 60);
    speedS = map(speedS, 0, 1023, 3, 30);
  }
}
----------------------------------------------------------------------------------------------------------------
